## net-tools 2.10

=== Makefile ===
#
# Makefile	Main Makefile for the net-tools Package
#
# NET-TOOLS	A collection of programs that form the base set of the
#		NET-3 Networking Distribution for the LINUX operating
#		system.
#
# Author:	Bernd Eckenfels <net-tools@lina.inka.de>
#		Copyright 1995-1996 Bernd Eckenfels, Germany
#
# URLs:		http://net-tools.sourceforge.net/
#
# Based on:	Fred N. van Kempen, <waltje@uwalt.nl.mugnet.org>
#		Copyright 1988-1993 MicroWalt Corporation
#
# Modifications:
#		Extensively modified from 01/21/94 onwards by
#		Alan Cox <A.Cox@swansea.ac.uk>
#		Copyright 1993-1994 Swansea University Computer Society
#
# Be careful!
# This Makefile doesn't describe complete dependencies for all include files.
# If you change include files you might need to do make clean.
#

# set the base of the Installation
# BASEDIR = /mnt
BASEDIR ?= $(DESTDIR)
BINDIR ?= /bin
SBINDIR ?= /sbin

# path to the net-lib support library. Default: lib
NET_LIB_PATH = lib
NET_LIB_NAME = net-tools

PROGS	:= ifconfig netstat route nameif

-include config.make
ifeq ($(HAVE_ARP_TOOLS),1)
PROGS	+= arp rarp
endif
ifeq ($(HAVE_HOSTNAME_TOOLS),1)
PROGS	+= hostname
endif
ifeq ($(HAVE_IP_TOOLS),1)
PROGS   += iptunnel ipmaddr
endif
ifeq ($(HAVE_MII),1)
PROGS	+= mii-tool
endif
ifeq ($(HAVE_PLIP_TOOLS),1)
PROGS	+= plipconfig
endif
ifeq ($(HAVE_SERIAL_TOOLS),1)
PROGS	+= slattach
endif

# Compiler and Linker Options
CFLAGS ?= -O2 -g
CFLAGS += -Wall
CFLAGS += -fno-strict-aliasing # code needs a lot of work before strict aliasing is safe
CPPFLAGS += -D_GNU_SOURCE
# Turn on transparent support for LFS
CPPFLAGS += -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE

ifeq ($(HAVE_AFDECnet),1)
DNLIB = -ldnet
endif

ifeq ($(origin CC), undefined)
CC	= gcc
endif
LD	= $(CC)
PKG_CONFIG ?= pkg-config

# -------- end of user definitions --------

MAINTAINER = net-tools-devel@lists.sourceforge.net
RELEASE	   = 2.10

.EXPORT_ALL_VARIABLES:

ifeq ("$(NET_LIB_PATH)","lib2")
TOPDIR   = ..
else
TOPDIR  := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)
endif

NET_LIB = $(NET_LIB_PATH)/lib$(NET_LIB_NAME).a

ifeq ($(HAVE_SELINUX),1)
SE_PC_CFLAGS := $(shell $(PKG_CONFIG) --cflags libselinux)
SE_PC_LIBS := $(shell $(PKG_CONFIG) --libs libselinux || echo -lselinux)
SELIB = $(SE_PC_LIBS)
CPPFLAGS += $(SE_PC_CFLAGS)
endif

CPPFLAGS += -I. -I$(TOPDIR)/include -I$(NET_LIB_PATH)
LDFLAGS  += -L$(NET_LIB_PATH)

SUBDIRS	= man/ $(NET_LIB_PATH)/

NLIB	= -l$(NET_LIB_NAME)

%.o:		%.c config.h version.h intl.h lib/net-features.h $<
		$(CC) $(CFLAGS) $(CPPFLAGS) -c $<

all:		config.h version.h subdirs $(PROGS)

config: 	cleanconfig config.h

install:	all installbin installdata

mostlyclean:
		rm -f -- *.o DEADJOE config.new *~ *.orig lib/*.o

clean: mostlyclean
		rm -f -- $(PROGS)
		@for i in $(SUBDIRS); do (cd $$i && $(MAKE) clean) ; done
		@cd po && $(MAKE) clean

cleanconfig:
		rm -f -- config.h

clobber: 	clean
		rm -f -- $(PROGS) config.h version.h config.status config.make
		@for i in $(SUBDIRS); do (cd $$i && $(MAKE) clobber) ; done


dist:
		rm -rf -- net-tools-$(RELEASE)
		git archive --prefix=net-tools-$(RELEASE)/ HEAD | tar xf -
		$(MAKE) -C net-tools-$(RELEASE)/po $@
		tar cf - net-tools-$(RELEASE)/ | xz > net-tools-$(RELEASE).tar.xz
		rm -rf -- net-tools-$(RELEASE)

distcheck:	dist
		tar xf net-tools-$(RELEASE).tar.xz
		yes "" | $(MAKE) -C net-tools-$(RELEASE) config
		$(MAKE) -C net-tools-$(RELEASE)
		rm -rf -- net-tools-$(RELEASE)
		@printf "\nThe tarball is ready to go:\n%s\n" "`du -b net-tools-$(RELEASE).tar.xz`"

config.h: 	config.in Makefile
		@echo "Configuring the Linux net-tools (NET-3 Base Utilities)..." ; echo
		@if [ config.status -nt config.in ]; \
			then ./configure.sh config.status; \
		   else ./configure.sh config.in; \
		 fi


version.h:	Makefile
		@echo "#define RELEASE \"net-tools $(RELEASE)\"" >version.h


$(NET_LIB):	config.h version.h intl.h libdir

i18n.h:		i18ndir

libdir:		version.h
		@$(MAKE) -C $(NET_LIB_PATH)

i18ndir:
		@$(MAKE) -C po

# use libdir target for lib/ to avoid parallel build issues
subdirs:	libdir
		@for i in $(SUBDIRS:$(NET_LIB_PATH)/=); do $(MAKE) -C $$i || exit $$? ; done

ifconfig:	$(NET_LIB) ifconfig.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ ifconfig.o $(NLIB) $(LDLIBS)

nameif:		$(NET_LIB) nameif.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ nameif.o $(NLIB) $(LDLIBS)

hostname:	hostname.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ hostname.o $(DNLIB) $(LDLIBS)

route:		$(NET_LIB) route.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ route.o $(NLIB) $(LDLIBS)

arp:		$(NET_LIB) arp.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ arp.o $(NLIB) $(LDLIBS)

rarp:		$(NET_LIB) rarp.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ rarp.o $(NLIB) $(LDLIBS)

slattach:	$(NET_LIB) slattach.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ slattach.o $(NLIB) $(LDLIBS)

plipconfig:	$(NET_LIB) plipconfig.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ plipconfig.o $(NLIB) $(LDLIBS)

netstat:	$(NET_LIB) netstat.o statistics.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ netstat.o statistics.o $(NLIB) $(SELIB) $(LDLIBS)

iptunnel:	$(NET_LIB) iptunnel.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ iptunnel.o $(NLIB) $(LDLIBS)

ipmaddr:	$(NET_LIB) ipmaddr.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ ipmaddr.o $(NLIB) $(LDLIBS)

mii-tool:	$(NET_LIB) mii-tool.o
		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ mii-tool.o $(NLIB) $(LDLIBS)

installbin:
	@echo
	@echo "######################################################"
	@echo "Notice: ifconfig and route are now installed into /bin"
	@echo "######################################################"
	@echo
	install -m 0755 -d ${BASEDIR}${SBINDIR}
	install -m 0755 -d ${BASEDIR}${BINDIR}
	install -m 0755 ifconfig   ${BASEDIR}${BINDIR}
	install -m 0755 nameif     ${BASEDIR}${SBINDIR}
	install -m 0755 netstat    ${BASEDIR}${BINDIR}
	install -m 0755 route      ${BASEDIR}${BINDIR}
ifeq ($(HAVE_ARP_TOOLS),1)
	install -m 0755 arp        ${BASEDIR}${SBINDIR}
	install -m 0755 rarp       ${BASEDIR}${SBINDIR}
endif
ifeq ($(HAVE_HOSTNAME_TOOLS),1)
	install -m 0755 hostname   ${BASEDIR}${BINDIR}
	ln -fs hostname $(BASEDIR)${BINDIR}/dnsdomainname
ifeq ($(HAVE_HOSTNAME_SYMLINKS),1)
	ln -fs hostname $(BASEDIR)${BINDIR}/ypdomainname
	ln -fs hostname $(BASEDIR)${BINDIR}/nisdomainname
	ln -fs hostname $(BASEDIR)${BINDIR}/domainname
endif
ifeq ($(HAVE_AFDECnet),1)
	ln -fs hostname $(BASEDIR)${BINDIR}/nodename
endif
endif
ifeq ($(HAVE_IP_TOOLS),1)
	install -m 0755 ipmaddr    $(BASEDIR)${SBINDIR}
	install -m 0755 iptunnel   $(BASEDIR)${SBINDIR}
endif
ifeq ($(HAVE_MII),1)
	install -m 0755 mii-tool   $(BASEDIR)${SBINDIR}
endif
ifeq ($(HAVE_PLIP_TOOLS),1)
	install -m 0755 plipconfig $(BASEDIR)${SBINDIR}
endif
ifeq ($(HAVE_SERIAL_TOOLS),1)
	install -m 0755 slattach   $(BASEDIR)${SBINDIR}
endif

installdata:
	$(MAKE) -C man install
	$(MAKE) -C po install

# End of Makefile.

=== po/Makefile ===
INSTALL=install -c
INSTALL_PROGRAM= ${INSTALL}
INSTALL_DATA= ${INSTALL} -m 644
INSTALLNLSDIR=${BASEDIR}/usr/share/locale

TUPDATE = msgmerge

NLSPACKAGE = net-tools

-include ../config.make
ALL_POS = $(wildcard *.po)
ALL_LANGS = $(ALL_POS:%.po=%)
ALL_CATALOGS = $(ALL_LANGS:%=%.mo)
ifeq ($(I18N),1)
ifeq ($(LINGUAS),)
LANGS = $(ALL_LANGS)
else
LANGS = $(filter $(LINGUAS),$(ALL_LANGS))
endif
else
LANGS =
endif
CATALOGS = $(LANGS:%=%.mo)

POTFILES=../arp.c ../hostname.c ../ifconfig.c ../netstat.c ../rarp.c \
	../route.c ../plipconfig.c ../iptunnel.c ../statistics.c \
	../lib/activate.c ../lib/af.c ../lib/arcnet.c ../lib/ash.c \
	../lib/ax25.c ../lib/ax25_gr.c ../lib/ddp.c ../lib/ddp_gr.c \
	../lib/econet.c ../lib/ether.c ../lib/fddi.c ../lib/frame.c \
	../lib/getargs.c ../lib/getroute.c ../lib/hdlclapb.c ../lib/hippi.c \
	../lib/hw.c ../lib/inet.c ../lib/inet6.c ../lib/inet6_gr.c \
	../lib/inet6_sr.c ../lib/inet_gr.c ../lib/inet_sr.c ../lib/ipx.c \
	../lib/ipx_gr.c ../lib/ipx_sr.c ../lib/loopback.c ../lib/masq_info.c \
	../lib/nstrcmp.c ../lib/netrom.c ../lib/netrom_gr.c ../lib/netrom_sr.c \
	../lib/ppp.c ../lib/ppp_ac.c ../lib/proc.c ../lib/rose.c \
	../lib/rose_gr.c ../lib/setroute.c ../lib/sit.c ../lib/slip.c \
	../lib/slip_ac.c ../lib/tr.c ../lib/tunnel.c ../lib/unix.c \
	../lib/util.c ../lib/interface.c ../lib/sockets.c ../lib/util-ank.c \
	../ipmaddr.c ../slattach.c ../iptunnel.c

all: $(NLSPACKAGE).pot $(CATALOGS)

$(NLSPACKAGE).pot: $(POTFILES)
	xgettext --default-domain=$(NLSPACKAGE) \
	  --add-comments --keyword=_ --keyword=N_ $(POTFILES)
	if cmp -s $(NLSPACKAGE).po $(NLSPACKAGE).pot; then \
	    rm -f -- $(NLSPACKAGE).po; \
	else \
	    mv $(NLSPACKAGE).po $(NLSPACKAGE).pot; \
	fi


update-po: Makefile
	$(MAKE) $(NLSPACKAGE).pot
	langs='$(ALL_LANGS)'; \
	for lang in $$langs; do \
		cat=$$lang.mo; \
		mv $$lang.po $$lang.old.po; \
		echo "$$lang:"; \
		if $(TUPDATE) $$lang.old.po $(NLSPACKAGE).pot > $$lang.po; then \
		rm -f -- $$lang.old.po; \
	else \
	 	echo "tupdate for $$cat failed!"; \
		rm -f -- $$lang.po; \
		mv $$lang.old.po $$lang.po; \
	fi; \
	done

clean:
	rm -f -- *mo

dist: $(ALL_CATALOGS)

distclean: clean
	rm -f -- .depend Makefile

depend:

install: $(CATALOGS)
	langs='$(LANGS)'; \
	for l in $$langs; do \
	    $(INSTALL) -m 755 -d $(INSTALLNLSDIR)/$$l; \
	    $(INSTALL) -m 755 -d $(INSTALLNLSDIR)/$$l/LC_MESSAGES; \
	    $(INSTALL) -m 644 $$l.mo $(INSTALLNLSDIR)/$$l/LC_MESSAGES/net-tools.mo; \
	done

%.mo: %.po
	msgfmt -o $@ $<

=== debian/changelog ===
net-tools (2.10-2) unstable; urgency=medium

  [ Helge Kreutzmann ]
  * Remove localized man pages and set proper transition rules to
    manpages-l10n. (Closes: #1108422)
  * Include missing man page ipmaddr.8.

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 26 Sep 2025 17:47:12 +0530

net-tools (2.10-1.3) unstable; urgency=medium

  [ Lena Voytek ]
  * Add new DEP8 tests for hostname and ifconfig

  [ Salvatore Bonaccorso ]
  * Non-maintainer upload.
  * Run ifconfig-lo-info autopkgtest with /usr/sbin in PATH for ifconfig
  * ipmaddr.c: Stack-based buffer Overflow in parse_hex()
  * Fix interface statistic regression.
    Thanks to Christian Herzog for the report (Closes: #1106147)
  * proc.c: Stack-based Buffer Overflow in net-tools (proc_gen_fmt)

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 22 May 2025 06:42:28 +0200

net-tools (2.10-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * CVE-2025-46836: interface.c: Stack-based Buffer Overflow in get_name()
    (Closes: #1105806)

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 15 May 2025 05:43:50 +0200

net-tools (2.10-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Release to unstable. (Closes: #1059409)

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 22 Apr 2024 01:55:29 +0200

net-tools (2.10-1) experimental; urgency=medium

  * Move to /usr-merge (DEP17).

 -- Utkarsh Gupta <utkarsh@debian.org>  Thu, 23 Nov 2023 14:41:07 +0000

net-tools (2.10-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update Martina's name and email address.
  * Drop DECnet support (Closes: #1024730)
  * Revert "Fix d/watch to point to upstream git repository"
  * New upstream version 2.10 (Closes: #1000281)

 -- Bastian Germann <bage@debian.org>  Fri, 25 Nov 2022 15:15:20 +0100

=== debian/control ===
Source: net-tools
Maintainer: Debian Networking Team <team+networking@tracker.debian.org>
Uploaders: Martina Ferrari <tina@debian.org>,
           Utkarsh Gupta <utkarsh@debian.org>
Section: net
Priority: important
Build-Depends: debhelper-compat (= 12),
               gettext,
               libselinux1-dev,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/debian/net-tools
Vcs-Git: https://salsa.debian.org/debian/net-tools.git
Homepage: http://sourceforge.net/projects/net-tools/

Package: net-tools
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: manpages-de (<<4.28.0-1), manpages-fr (<<4.28.0-1), manpages-pt-br (<<4.28.0-1)
Description: NET-3 networking toolkit
 This package includes the important tools for controlling the network
 subsystem of the Linux kernel.  This includes arp, ifconfig, netstat,
 rarp, nameif and route.  Additionally, this package contains utilities
 relating to particular network hardware types (plipconfig, slattach,
 mii-tool) and advanced aspects of IP configuration (iptunnel, ipmaddr).
 .
 In the upstream package 'hostname' and friends are included. Those are
 not installed by this package, since there is a special "hostname*.deb".

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(origin CC),default)
    CC := $(DEB_HOST_GNU_TYPE)-gcc
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
    PKG_CONFIG ?= $(DEB_HOST_GNU_TYPE)-pkg-config
    export PKG_CONFIG
endif

COPTS := -D_GNU_SOURCE -Wall $(shell dpkg-buildflags --get CFLAGS) \
    $(shell dpkg-buildflags --get CPPFLAGS)
LOPTS := $(shell dpkg-buildflags --get LDFLAGS)

PROGS    = ifconfig arp netstat route rarp slattach plipconfig \
    nameif iptunnel ipmaddr mii-tool
MANPAGES = arp.8 ethers.5 ifconfig.8 mii-tool.8 nameif.8 netstat.8 \
	   plipconfig.8 rarp.8 route.8 slattach.8 ipmaddr.8
DEB_MANPAGES = iptunnel.8

%:
	dh $@

override_dh_auto_configure:
	[ ! -f config.make ] || mv config.make debian/config.make.bk
	cp -f debian/config.make config.make
	[ ! -f config.h ] || mv config.h debian/config.h.bk
	cp -f debian/config.h config.h

override_dh_auto_build:
	$(MAKE) CC="$(CC)" COPTS="$(COPTS)" LOPTS="$(LOPTS)" PROGS="$(PROGS)"

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) clobber
	[ ! -f debian/config.h.bk ] || \
		mv debian/config.h.bk config.h
	[ ! -f debian/config.make.bk ] || \
		mv debian/config.make.bk config.make
	dh_auto_clean

override_dh_auto_install:
	$(MAKE) -C po install BASEDIR=$(CURDIR)/debian/net-tools
	dh_installman --language=C \
		$(wildcard $(addprefix man/en_US/,$(MANPAGES)))
	dh_installman --language=C \
		$(wildcard $(addprefix debian/,$(DEB_MANPAGES)))

=== debian/watch ===
version=4

https://qa.debian.org/watch/sf.php/net-tools/ \
    net-tools-(\d+\.\d+(?:\.\d+)?)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
